#include "shift_hal.h"

typedef unsigned int DATA_LCD;

DATA_LCD m_ShiftData = 0;

void shift_delay(int time)
{
    int j;
    
    while(time)
    {
		for(j=0;j<1;j++);
        time--;
    }
}

void InitShfitRegister(void)				
{
	Sbi(SHIFT_DATA_DDR, SHIFT_DATA_BIT);
	Sbi(SHIFT_CLK_DDR, SHIFT_CLK_BIT);
	Sbi(SHIFT_LATCH_DDR, SHIFT_LATCH_BIT);

	ShiftLatchClear();
	ShiftClkClear(); 
}

void ShiftOut(DATA_LCD Data)
{
    char i = 0;
    
    for(i=0;i<MAX_SHIFT_NUM;i++)
    {
        //Data Out
        if( (_FIRST_595DATA>>i)&(Data) )ShiftDataSet();        
       	else ShiftDataClear();

        //shift_delay(1);
                
        //Shift Clk Out
        ShiftClkSet();
        shift_delay(2);
        ShiftClkClear();
    }
    
   // shift_delay(1);
    //Latch Clk Out   
    ShiftLatchSet();
    shift_delay(2);
    ShiftLatchClear();
} 


void SetLShiftData(unsigned char Data)
{
    m_ShiftData = (m_ShiftData & 0xFF00) | (Data);
    
	ShiftOut(m_ShiftData);
}
//-----------------------------------------------------------------------------
