//-----------------------------------------------------------------------------
// [MSP430 EVM] Test Program
//
// by http://cafe.naver.com/elab
//-----------------------------------------------------------------------------
#include "fnd_m.h"
#include "../00_hal/shift.c"

void FndInit(void)
{
	InitShfitRegister();
	ShiftOut(0xFFFF);
}

void FndOut(unsigned int Num)
{
	unsigned int fnd_value[] = {FND0, FND1, FND2, FND3, FND4, FND5, FND6, FND7, FND8, FND9};
	unsigned int value = 0;
	
	value = fnd_value[Num/10];
    value |= fnd_value[Num%10]<<8;
	
    ShiftOut(~value);
}
